var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
// Base Dependencies
import { Component, ViewChild } from '@angular/core';
import { NavController, NavParams, MenuController, normalizeURL } from 'ionic-angular';
import uuid from 'uuid/v1';
// Ionic Native plugins
import { StatusBar } from '@ionic-native/status-bar';
import { CameraPreview } from '@ionic-native/camera-preview';
import { File } from '@ionic-native/file';
import { DeviceMotion } from '@ionic-native/device-motion';
// Components
import { EditComponent } from '../edit/edit';
// Helpers
import { base64toBlob, rotateBase64Image } from '../../helpers/picture-mutations';
var CameraComponent = /** @class */ (function () {
    function CameraComponent(navCtrl, navParams, menu, statusBar, cameraPreview, file, deviceMotion) {
        this.navCtrl = navCtrl;
        this.navParams = navParams;
        this.menu = menu;
        this.statusBar = statusBar;
        this.cameraPreview = cameraPreview;
        this.file = file;
        this.deviceMotion = deviceMotion;
        this.pictures = [];
        this.doesExit = false;
        // Flash Mode
        this.showFlashOptions = false;
        this._activeFlashMode = 'auto';
        this.callback = this.navParams.get('callback');
        this.pictureOptions = this.navParams.get('pictureOptions') || {
            quality: 80,
            width: 4096,
            height: 4096
        };
        this.translations = this.navParams.get('translations') || {
            cancel: 'Cancel',
            finish: 'Finish',
            auto: 'AUTO',
            on: 'On',
            off: 'Off'
        };
    }
    Object.defineProperty(CameraComponent.prototype, "activeFlashMode", {
        get: function () {
            return this._activeFlashMode;
        },
        set: function (newValue) {
            var _this = this;
            this.cameraPreview.setFlashMode(newValue)
                .then(function () {
                _this._activeFlashMode = newValue;
                _this.showFlashOptions = false;
            })
                .catch(function (err) {
                _this.errorHandler(err);
            });
        },
        enumerable: true,
        configurable: true
    });
    CameraComponent.prototype.ionViewWillEnter = function () {
        this.menu.swipeEnable(false);
        this.statusBar.styleBlackOpaque();
    };
    CameraComponent.prototype.ionViewDidEnter = function () {
        var _this = this;
        this.startCam();
        this.motionSubscription = this.deviceMotion.watchAcceleration({ frequency: 500 }).subscribe(function (acceleration) {
            _this.deviceOrientation = acceleration;
        });
    };
    CameraComponent.prototype.ionViewWillLeave = function () {
        if (this.doesExit) {
            this.menu.swipeEnable(true);
            this.statusBar.styleDefault();
        }
    };
    CameraComponent.prototype.ionViewDidLeave = function () {
        if (this.doesExit) {
            this.stopCam();
            this.motionSubscription.unsubscribe();
        }
    };
    CameraComponent.prototype.focus = function (event) {
        var headerHeight = this.header.nativeElement.offsetHeight;
        this.cameraPreview.tapToFocus(event.offsetX, event.offsetY + headerHeight);
    };
    CameraComponent.prototype.switchCamera = function () {
        var _this = this;
        this.cameraPreview.switchCamera()
            .then(function () {
        })
            .catch(function (err) {
            _this.errorHandler(err);
        });
    };
    CameraComponent.prototype.cancel = function () {
        var _this = this;
        var i = this.pictures.length;
        this.pictures.forEach(function (picture) {
            picture.fileEntry.remove(function () {
                i--;
                if (i === 0) {
                    _this.pictures = [];
                    _this.exit();
                }
            }, function (err) {
                _this.errorHandler(err);
            });
        });
        if (i === 0) {
            this.exit();
        }
    };
    CameraComponent.prototype.takePicture = function () {
        var _this = this;
        this.cameraPreview.takePicture(this.pictureOptions)
            .then(function (picture) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            var fileOptions;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.rotateImageBasedOnOrientation(picture)];
                    case 1:
                        picture = _a.sent();
                        fileOptions = {
                            replace: true
                        };
                        this.file.writeFile(this.file.cacheDirectory, uuid() + '.jpeg', base64toBlob(picture, 'image/jpeg'), fileOptions)
                            .then(function (fileEntry) {
                            var normalizedURL = normalizeURL(fileEntry.toURL());
                            _this.pictures.push({
                                fileEntry: fileEntry,
                                normalizedURL: normalizedURL,
                                base64Data: picture
                            });
                        })
                            .catch(function (err) {
                            _this.errorHandler(err);
                        });
                        return [2 /*return*/];
                }
            });
        }); })
            .catch(function (err) {
            _this.errorHandler(err);
        });
    };
    CameraComponent.prototype.finish = function () {
        this.exit();
    };
    CameraComponent.prototype.editPicture = function (picture, index) {
        this.navCtrl.push(EditComponent, {
            picture: picture,
            array: this.pictures,
            index: index
        });
    };
    CameraComponent.prototype.errorHandler = function (error) {
        this.callback({
            error: error
        });
        this.doesExit = true;
        this.navCtrl.pop();
    };
    CameraComponent.prototype.exit = function () {
        this.callback({
            pictures: this.pictures
        });
        this.doesExit = true;
        this.navCtrl.pop();
    };
    CameraComponent.prototype.startCam = function () {
        var _this = this;
        var cameraPreviewOpts = {
            x: 0,
            y: 0,
            width: window.screen.width,
            height: window.screen.height,
            camera: 'rear',
            tapPhoto: false,
            previewDrag: false,
            toBack: true,
            alpha: 1
        };
        this.cameraPreview.startCamera(cameraPreviewOpts)
            .then(function () {
            _this.cameraPreview.setFlashMode('auto')
                .then(function () {
            })
                .catch(function (err) {
                _this.errorHandler(err);
            });
        })
            .catch(function (err) {
            if (err.indexOf('Camera already started') !== -1) {
                _this.cameraPreview.setFlashMode('auto')
                    .then(function () {
                })
                    .catch(function (err) {
                    _this.errorHandler(err);
                });
            }
            else {
                _this.errorHandler(err);
            }
        });
    };
    CameraComponent.prototype.stopCam = function () {
        this.cameraPreview.stopCamera();
    };
    CameraComponent.prototype.rotateImageBasedOnOrientation = function (imageData) {
        if (this.deviceOrientation) {
            // If landscape
            if (Math.abs(this.deviceOrientation.x) > Math.abs(this.deviceOrientation.y)) {
                if (this.deviceOrientation.x > 0) {
                    return rotateBase64Image(imageData, 270);
                }
                else {
                    return rotateBase64Image(imageData, 90);
                }
            }
            else {
                // Portrait upside-down
                if (this.deviceOrientation.y < 0) {
                    return rotateBase64Image(imageData, 180);
                }
                else {
                    // Right-side up
                    return new Promise(function (resolve) {
                        resolve(imageData);
                    });
                }
            }
        }
        else {
            return new Promise(function (resolve) {
                resolve(imageData);
            });
        }
    };
    CameraComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ionic-multi-camera',
                    template: '<ion-header no-border #header><ion-toolbar color="camera"><ion-buttons left><button ion-button icon-only clear (click)="showFlashOptions = !showFlashOptions"><ion-icon name="flash"></ion-icon></button></ion-buttons><ion-segment color="light" *ngIf="showFlashOptions" [(ngModel)]="activeFlashMode"><ion-segment-button value="auto">{{ translations.auto }}</ion-segment-button><ion-segment-button value="on">{{ translations.on }}</ion-segment-button><ion-segment-button value="off">{{ translations.off }}</ion-segment-button></ion-segment><ion-buttons right><button ion-button icon-only clear *ngIf="!showFlashOptions" (click)="switchCamera()"><ion-icon name="reverse-camera"></ion-icon></button></ion-buttons></ion-toolbar></ion-header><ion-content (click)="focus($event)"></ion-content><ion-footer no-border><ion-row nowrap justify-content-start align-items-center><ion-col *ngFor="let picture of pictures; let i = index" col-auto><img tappable [src]="\'data:image/jpeg;base64,\' + picture.base64Data" class="thumbnail" (click)="editPicture(picture, i)"></ion-col></ion-row><ion-toolbar color="camera" class="footer-bar"><ion-buttons left><button ion-button (click)="cancel()">{{ translations.cancel }}</button></ion-buttons><button ion-button icon-only clear large color="light" (click)="takePicture()" class="photo-button"><ion-icon name="ios-radio-button-on-outline"></ion-icon></button><ion-buttons right><button ion-button (click)="finish()">{{ translations.finish }}</button></ion-buttons></ion-toolbar></ion-footer>',
                    styles: [".photo-button {  font-size: 50px;  position: absolute;  left: 50%;  transform: translate(-50%, -50%); }.footer-bar {  padding-bottom: 30px;  padding-bottom: calc(30px + constant(safe-area-inset-bottom)) !important;  padding-bottom: calc(30px + env(safe-area-inset-bottom)) !important;  min-height: 110px;  min-height: calc(110px + constant(safe-area-inset-bottom)) !important;  min-height: calc(110px + env(safe-area-inset-bottom)) !important; }ion-row {  overflow-x: scroll; }.thumbnail {  width: 60px;  height: 60px;  min-width: 60px;  min-height: 60px; }"]
                },] },
    ];
    /** @nocollapse */
    CameraComponent.ctorParameters = function () { return [
        { type: NavController, },
        { type: NavParams, },
        { type: MenuController, },
        { type: StatusBar, },
        { type: CameraPreview, },
        { type: File, },
        { type: DeviceMotion, },
    ]; };
    CameraComponent.propDecorators = {
        'header': [{ type: ViewChild, args: ['header',] },],
    };
    return CameraComponent;
}());
export { CameraComponent };
//# sourceMappingURL=camera.js.map