// Base Dependencies
import { Injectable } from '@angular/core';
import { App } from 'ionic-angular';
// Components
import { CameraComponent } from '../pages/camera/camera';
var IonicMultiCamera = /** @class */ (function () {
    function IonicMultiCamera(app) {
        this.app = app;
        this.navCtrl = this.app.getActiveNavs()[0];
    }
    IonicMultiCamera.prototype.getPicture = function (pictureOptions, translations) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var getData = function (data) {
                if (data.error) {
                    reject(data.error);
                }
                else {
                    resolve(data.pictures);
                }
                return Promise.resolve();
            };
            _this.navCtrl.push(CameraComponent, {
                callback: getData,
                pictureOptions: pictureOptions,
                translations: translations
            });
        });
    };
    IonicMultiCamera.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    IonicMultiCamera.ctorParameters = function () { return [
        { type: App, },
    ]; };
    return IonicMultiCamera;
}());
export { IonicMultiCamera };
//# sourceMappingURL=ionic-multi-camera.js.map